+++
title = "Run a script"
weight = 20
+++

## Running a script

To get started with BornAgain scripting, run a first example.

We assume that BornAgain and Python are
[installed]({{% relref "installation" %}})
and that you verified that the Python interpreter can
[find]({{% ref-py "start/find.md" %}}) the module `bornagain`.

Download the following example script, and save it under the name `AlternatingLayers.py`.

Alternatively, all example scripts can also be found in the BornAgain distribution:

<!-- Nav tabs -->
<ul class="nav nav-tabs" id="OperationSystemTab" role="tablist">
  <li class="nav-item">
    <a class="nav-link active" id="home-tab" data-toggle="tab" href="#Windows" role="tab" aria-controls="windows" aria-selected="true">Windows</a>
  </li>
  <li class="nav-item">
    <a class="nav-link" id="profile-tab" data-toggle="tab" href="#MacOS" role="tab" aria-controls="macos" aria-selected="false">MacOS</a>
  </li>
  <li class="nav-item">
    <a class="nav-link" id="messages-tab" data-toggle="tab" href="#Linux" role="tab" aria-controls="linux" aria-selected="false">Linux</a>
  </li>
</ul>

<!-- Tab panes -->
<div class="tab-content id="OperationSystemTabContent">
  <div class="tab-pane active" id="Windows" role="tabpanel" aria-labelledby="windows-tab">
    <p><pre><code>C:\BornAgain-{{< release-string >}}\Examples\python</code></pre></p>
  </div>
  <div class="tab-pane" id="MacOS" role="tabpanel" aria-labelledby="macos-tab">
    <p><pre><code>/Applications/BornAgain.app/Contents/share/BornAgain-{{< release-string-short >}}/Examples/python</code></pre></p>
  </div>
  <div class="tab-pane" id="Linux" role="tabpanel" aria-labelledby="linux-tab">
    <p><pre><code>install_dir/share/BornAgain-{{< release-string-short >}}/Examples/python</code></pre></p>
  </div>
</div>

{{< highlightfile file="Examples/specular/AlternatingLayers.py">}}
<p>

For a discussion of the content of this script,
see [simulation/reflectometry]({{% ref-py "simulation/reflectometry/_index.md" %}}).

### From the command line

At the command prompt in a terminal, launch the script with the command
```bash
python AlternatingLayers.py
```
(on systems that still have Python2, the command may rather be `python3`).

As result, a MatPlotLib window should pop up, and display this reflectometry curve:

{{< figscg src="/files/simulated/AlternatingLayers.png" width="500" class="center">}}

#### Short call (*nix)

Under *nix (Linux, MacOS),
the script can also be launched without typing `python` at the command prompt:
```bash
AlternatingLayers.py
```
This is made possible by the line "`#!/usr/bin/env python3`" on top of the script.
It may be necessary to make the script executable by
```bash
chmod a+x AlternatingLayers.py
```
